#!/usr/bin/perl
# Data preprocessing: sampling.pl filename percent 
#                                    sampling.pl percent
#                                    sampling.pl
#
# Sampling data  from filename (default "ACC47.csv") picking only percent% (default 1)
# Written by Krung Sinapiromsaran, 4 July 2007

# Extract initial setting
$filename = "ACC47.csv";
if($#ARGV > 0) { $filename = $ARGV[0]; $percent = $ARGV[1]; }
else { $percent = ($ARGV[0])?$ARGV[0]:1; }

$outfilename = "sampling" . $percent . $filename;

# Start a selection process
open(FD, $filename) || die "Error in $filename\n";
open(OUTFD, ">$outfilename") || die "Cannot write $outfilename";
 
 # Keep the first line (header row) of data
 $firstline = <FD>; print OUTFD $firstline;
 
 # The rest of data file
 while($line = <FD>) { print OUTFD $line if rand() <= $percent/100; }
close(OUTFD);
close(FD);
print "$outfilename has been created\n";

